#include "Song.h"
#include "Arduino.h"

// Konstruktor
Song::Song(int laenge, String* notes, int* beats, int tempo) {
  this->laenge = laenge;    //Anzahl der Noten
  this->notes = notes;      //Tonhöhen
  this->beats = beats;      //Länge der Töne
  this->tempo = tempo;      //Geschwindigkeit des Liedes

}
// Methoden
void Song::play() {                 //spielt den Song ab
  for (int i = 0; i < laenge; i++) {
    if (notes[i] == " ") {
      delay(beats[i] * tempo);      //wenn " " dann wird eine Pause gespielt
    } else {
      playNote(notes[i], beats[i] * tempo); //ansonsten wird die Methode playNote aufgerufen (duration = beats[i] * tempo)
    }
    delay(tempo / 2);     //Pause zwischen einzelnen Noten
  }
}

void Song::playTone(int sound, int duration) {         //spielt genau spezifizierten Ton
  for (long i = 0; i < duration * 1000L; i += sound * 2) {    //bestimmt die Länge der Töne
    tone(speakerPin, sound);                                  //Gibt Ton in entsprechender Länge aus
  }
  noTone(speakerPin);                                         //schaltet den Ton wieder aus, um einzelne Töne hören zu können
  delay(1);
}

void Song::playNote(String note, int duration) {        //spielt den Ton, der dem Notennamen zugewiesen ist
  String names[] = {"g2", "gis2", "a2", "ais2", "h2", "c3", "cis3", "d3", "dis3", "e3", "f3", "fis3", "g3", "gis3", "a3", "ais3", "h3", "c4", "cis4", "d4", "dis4", "e4", "f4", "fis4", "g4", 
                  "gis4", "a4", "ais4", "h4", "c5", "cis5", "d5", "dis5"};
  int tones[] = { 196, 208, 220, 233, 247, 262, 277, 294, 311, 330, 349, 370, 392, 415, 440, 466, 494, 523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988, 1047, 1109, 1175, 1245};
 
  for (int i = 0; i < 33; i++) {
    if (note == names[i]) {
      playTone(tones[i], duration);     //ruf die playTone Methode auf
    }
  }
}

