import processing.serial.*;
import java.util.HashMap;
Serial myPort;
String value;
String val = " ";
int endCounter = 0;
boolean wasRight = false;
boolean menueMode = true;
boolean gameMode = false;
boolean endScreen = false;
color Txt = color(0, 0, 0);
color Chosen = color(0, 95, 106);
color cfdk = Chosen;  //Farben der auszuwählenden Songs im Menü
color cpp = Txt;
color came = Txt;
color cfroz = Txt;

static int numberWhite = 0;    //Anzahl der bisher erzeugten weißen Tasten
static int numberBlack = 0;    //Anzahl der bisher erzeugten schwarzen Tasten
static int widthWhite = 75;     //Breite einer weißen Taste
static int initialXPos = 20;    //x-Position der ersten Taste
int norm = 120;                 //Graustufe des Hintergrunds
color wrong = color(204, 0, 0);
color end = color(0, 0, 255);
color bg = norm;

HashMap<String, Key> keys = new HashMap<String, Key>();

void setup() {
  size(2200, 1000);
  String[] ports = Serial.list();
  String portName = ports[ports.length-1]; 
  myPort = new Serial(this, portName, 1200);

  keys.put("c2", new Key());        //Tasten-Objekte erzeugen und in der Hash-Map speichern
  keys.put("d2", new Key());
  keys.put("e2", new Key());
  keys.put("f2", new Key());
  keys.put("g2", new Key());
  keys.put("a2", new Key());
  keys.put("h2", new Key());
  keys.put("c3", new Key());
  keys.put("d3", new Key());
  keys.put("e3", new Key());
  keys.put("f3", new Key());
  keys.put("g3", new Key());
  keys.put("a3", new Key());
  keys.put("h3", new Key());
  keys.put("c4", new Key());
  keys.put("d4", new Key());
  keys.put("e4", new Key());
  keys.put("f4", new Key());
  keys.put("g4", new Key());
  keys.put("a4", new Key());
  keys.put("h4", new Key());
  keys.put("c5", new Key());
  keys.put("d5", new Key());

  keys.put("cis2", new BlackKey());
  keys.put("dis2", new BlackKey());
  keys.put("fis2", new BlackKey());
  keys.put("gis2", new BlackKey());
  keys.put("ais2", new BlackKey());
  keys.put("cis3", new BlackKey());
  keys.put("dis3", new BlackKey());
  keys.put("fis3", new BlackKey());
  keys.put("gis3", new BlackKey());
  keys.put("ais3", new BlackKey());
  keys.put("cis4", new BlackKey());
  keys.put("dis4", new BlackKey());
  keys.put("fis4", new BlackKey());
  keys.put("gis4", new BlackKey());
  keys.put("ais4", new BlackKey());
  keys.put("cis5", new BlackKey());
}

void draw() {
  clear();
  background(bg);

  if (menueMode) {

    textSize(75);                        //Auswahlmöglichkeiten anzeigen
    fill(cfdk);
    text("Fluch der Karibik", 100, 100);
    fill(cpp);
    text("Pink Panther", 100, 200);
    fill(came);
    text("Alle meine Entchen", 100, 300);
    fill(cfroz);
    text("Frozen", 100, 400);


    value = myPort.readStringUntil('\n');  //Aktuelle Auswahl farbig markieren (Lesen des vom Arduino übermittelten Strings)
    if (value != null) {
      if (value.length() == 3) {
        if (value.substring(0, 1).equals("0")) {
          cfdk = Chosen;
          cpp = Txt;
          came = Txt;
          cfroz = Txt;
        }
        if (value.substring(0, 1).equals("1")) {
          cfdk = Txt;
          cpp = Chosen;
          came = Txt;
          cfroz = Txt;
        }
        if (value.substring(0, 1).equals("2")) {
          cfdk = Txt;
          cpp = Txt;
          came = Chosen;
          cfroz = Txt;
        }
        if (value.substring(0, 1).equals("3")) {
          cfdk = Txt;
          cpp = Txt;
          came = Txt;
          cfroz = Chosen;
        }
      }
      if (value.length() == 7) {                      //wenn der Taster zum Beginnen des Spielens gedrückt wurde
        if (value.substring(0, 5).equals("begin")) {
          menueMode = false;
          gameMode = true;
        }
      }
    }
  }

  if (gameMode) {
    keys.get("c2").drawKey();    //weiße Tasten zeichnen
    keys.get("d2").drawKey();
    keys.get("e2").drawKey();
    keys.get("f2").drawKey();
    keys.get("g2").drawKey();
    keys.get("a2").drawKey();
    keys.get("h2").drawKey();
    keys.get("c3").drawKey();
    keys.get("d3").drawKey();
    keys.get("e3").drawKey();
    keys.get("f3").drawKey();
    keys.get("g3").drawKey();
    keys.get("a3").drawKey();
    keys.get("h3").drawKey();
    keys.get("c4").drawKey();
    keys.get("d4").drawKey();
    keys.get("e4").drawKey();
    keys.get("f4").drawKey();
    keys.get("g4").drawKey();
    keys.get("a4").drawKey();
    keys.get("h4").drawKey();
    keys.get("c5").drawKey();
    keys.get("d5").drawKey();

    value = myPort.readStringUntil('\n');
    println(value);

    if (value != null) {

      if (value.length() == 4) {
        val = value.substring(0, 2);    //wenn der Name einer weißen Taste gesendet wurde
      } else if (value.length() == 6) {
        val = value.substring(0, 4);    //wenn der Name einer schwarzen Taste gesendet wurde
      } else if (value.length() == 7) {
        //println(value);
        wasRight = false;               //wenn "false" gesendet wurde
        bg = wrong;
      } else if (value.length() == 9) {
        wasRight = true;                //wenn "correct" gesendet wurde
        bg = norm;
      } else if (value.length() == 10) {    //wenn gameover gesendet wurde
        gameMode = false;
        endScreen = true;
      }

      for (Key k : keys.values()) {    //vorherige Markierungen rückgängig machen
        k.unindicate();
      }
      keys.get(val).indicate();        //zuletzt gesendete Taste markieren
    }

    keys.get("cis2").drawKey();    //schwarze Tasten zeichnen
    keys.get("dis2").drawKey();
    keys.get("fis2").drawKey();
    keys.get("gis2").drawKey();
    keys.get("ais2").drawKey();
    keys.get("cis3").drawKey();
    keys.get("dis3").drawKey();
    keys.get("fis3").drawKey();
    keys.get("gis3").drawKey();
    keys.get("ais3").drawKey();
    keys.get("cis4").drawKey();
    keys.get("dis4").drawKey();
    keys.get("fis4").drawKey();
    keys.get("gis4").drawKey();
    keys.get("ais4").drawKey();
    keys.get("cis5").drawKey();
  }
  if (endScreen) {          //Anzeigen des Scores und Rückkehr zum Menü
    endCounter++;
    value = myPort.readStringUntil('\n');
    if (value != null) {
      val = value.substring(0, value.length()-2);
    }
     textSize(75);
     fill(Chosen);
     text("Your score is: "+val, 100, 100);
    if (endCounter > 1000) {
      endScreen = false;
      menueMode = true;
    }
  }
}
